﻿$engine JScript
$uname dev_sosna
$dname DEV макросы
$addin global
$addin stdcommands
$addin stdlib

global.connectGlobals(SelfScript)
stdlib.require('TextWindow.js', SelfScript);
function hookCompareFiles(dlgInfo)
{
   if(dlgInfo.stage == openModalWnd)
   {
      Message(dlgInfo.Caption);
      // Пример перебора контролов на форме
      //Message("HWND = 0x" + dlgInfo.form.hwnd.toString(16));
      for(var c = 0; c < dlgInfo.form.controlsCount; c++)
      {
         var ctr = dlgInfo.form.getControl(c)
         Message(ctr.name + "   " + ctr.value)
      }
        /*      for (var key in dlgInfo.form) {
        Message(" key "+key+" :"+dlgInfo[key])
        } */
      //events.disconnect(windows, "onDoModal", SelfScript.self, "hookCompareFiles")
      //dlgInfo.form.getControl("FirstFile").value = "путь1"
      //dlgInfo.form.getControl("SecondFile").value = "путь2"
      //var wsh = new ActiveXObject("WScript.Shell")
      //wsh.SendKeys('^~')
   } else {
        Message("stage "+dlgInfo.stage+ " caption "+dlgInfo.Caption );
   }
}

function macrosЗапуститьТест()
{
   events.connect(windows, "onDoModal", SelfScript.self, "hookCompareFiles")
   //stdcommands.Frame.CompareFiles.send()
}

// Получить полное имя объекта метаданных
function getFullMDName(mdObj)
{
    if(!mdObj)
        return "no object"
    var names = []
    while(true)
    {
        names.unshift(mdObj.name)
        var className = mdObj.mdclass.name(1)
        if(!className.length || !mdObj.parent)
        {
            names.unshift(mdObj.container.identifier)
            break
        }
        names.unshift(className)
        mdObj = mdObj.parent
    }
    return names.join('.')
}

// Возвращает читаемое имя для состояния отображения
function state(s)
{
    switch(s)
    {
        case 1:
            return 'vsDock'
        case 2:
            return 'vsFloat'
        case 4:
            return 'vsMDI'
        case 8:
            return 'vsHardDock'
        case 16:
          return 'vsHiding'
      default:
            return s
   }
}
// Возвращает читаемое имя для положения отображения
function placement(s)
{
    switch(s)
    {
        case 1:
            return 'vpLeft'
        case 2:
            return 'vpTop'
        case 4:
            return 'vpRight'
        case 8:
            return 'vpBottom'
        case 16:
          return 'vpCenter'
        case 32:
          return 'vpTabbed'
      default:
            return s
   }
}

// Вывод инфы об отображении и его дочерних отображений
function printView(view, indent)
{
    Message(indent + "id = " + view.id, mExc1)
    Message(indent + " Title = " + view.title)
    Message(indent + " HWND = 0x" + view.hwnd.toString(16))
    Message(indent + " wndClass = " + view.wndClass)
    Message(indent + " container = " + view.isContainer)
    var pos = view.position()
    Message(indent + " pos.state = " + state(pos.state))
    Message(indent + " pos.placement = " + placement(pos.placement))
    var parent = view.parent
    if(parent)
        Message(indent + " parent id = " + parent.id)
   
    var childs = view.enumChilds()
    Message(indent + " childs = " + childs.count)
    for(var k = 0; k < childs.count; k++)
        printView(childs.item(k), indent + '\t')
}

// Распечатка MDI отображений
function macrosPrintMdiViews()
{
    var mdiWnds = windows.mdiView.enumChilds()
    Message("Mdi windows=" + mdiWnds.count)
    for(var k = 0, c = mdiWnds.count; k < c; k++)
        printView(mdiWnds.item(k), '')
}
// Распечатка всех отображений
function macrosPrintViewsFromRoot()
{
    printView(windows.mainView, "")
}
// Проверка активного и фокусного отображения
function macrosTestActiveView()
{
    // Активное и фокусное отображение могут отличаться. Например, если фокус в строке поиска в стандартном тулбаре
    Message("Active view")
    printView(windows.getActiveView(), '')
    Message("Focused view")
    printView(windows.getFocusedView(), '')
}
// Проверка различных свойств активного отображения
function macrosТestViewMD()
{
    var v = windows.getActiveView()
    printView(v, '')
    var text = getFullMDName(v.mdObj)
    var mdProp = v.mdProp
    if(mdProp)
    {
        var n = mdProp.name(1)
        text += "::" + n
        if(n == "Макет")
            text += " (" + toV8Value(v.mdObj.property("ТипМакета")).presentation() + ")"
    }
    Message(text)
    var obj = v.getObject()
    if(obj)
        Message("object - " + toV8Value(obj).typeName(1))
}

function printMdObj(mdObj, indent, text, path)
{
    //попробуем разложить структуру конфигурации в файловую структуру. 
    //FIXME: вроде как есть свойство для записи свойства элемента (во внутреннем формате), проверить а работает ли.  
    // Получим и покажем класс объекта
    var mdc = mdObj.mdclass
    text = []
    text.push("mdclass " + mdc.name(1) +" id "+mdObj.id + " name " + mdObj.name)
    //if (mdc.name(1)=="Конфигурация") {
    path = path+"\\"+mdObj.name;
    CreateDirectory(path);
    //}
    try {
        //Message("id "+mdc.id +" "+mdc.presentation()+ "  "+mdc.toStringInternal().split("\n"))
        //Message("id "+mdc.id +"  "+mdc.toStringInternal().split("\n"))
    } catch (e){
        //Message("cath")
    }
    // Переберем свойства объекта. Количество доступных свойств объекта
    // определяется в его классе. Сами свойства объекта получаются методом
    // property(индекс), где индекс может быть - порядковым номером свойства (с нуля)
    // или названием свойства, или строкой с гуидом свойства
    for(var i = 0, c = mdc.propertiesCount; i < c; i++)
    {
        var mdProp = mdc.propertyAt(i)
        var propVal = toV8Value(mdObj.property(i))
        if (mdObj.isPropModule(mdProp.id)) {
            //var text = getFullMDName(mdProp)
            var d = v8New("ТекстовыйДокумент")
            d.УстановитьТекст(mdObj.getModuleText(mdProp.id))
            d.Write(path+"\\"+mdProp.name(1)+".1s");
            continue;
            //text.push(indent + " Это модуль ");
        }
        //{if (propVal.presentation() == "НеизвестныйОбъект") {
            //toV8Value(mdRefValue).toStringInternal().split("\n")
            //text.push(indent + " prop " + mdProp.name(1) + " " + mdProp.id + " = " + propVal.toStringInternal().split("\n")+" id "+propVal.id + " "+propVal.name(1))
        //    text.push(indent + " prop " + mdProp.name(1) + " " + mdProp.id + " = " + propVal.toStringInternal().split("\n"))
        //} else {
            text.push(" prop " + mdProp.name(1) + " " + mdProp.id + " = " + propVal.presentation() + " to string "+propVal.toStringInternal().split("\n"))
        //}
        
    }
    //if (mdc.name(1)=="Конфигурация") {
    var d = v8New("ТекстовыйДокумент")
    d.УстановитьТекст(text.join('\n'))
    d.Write(path+"\\Propertys.txt")
        
    //}
    // Перебираем классы потомков (например у Документа это Реквизиты, ТабличныеЧасти, Формы)
    for(var i = 0; i < mdc.childsClassesCount; i++)
    {
        var childMdClass = mdc.childClassAt(i)
        // Покажем название на русском языке во множественной форме
        // text.push(""+childMdClass.name(1, true))
        // Теперь переберем потомков этого класса.
        var first = true;
        for(var chldidx = 0, c = mdObj.childObjectsCount(i); chldidx < c; chldidx++)
            if (first) {
            path = path+"\\"+childMdClass.name(1, true);
            CreateDirectory(path);
            first = false;
            }
            printMdObj(mdObj.childObject(i, chldidx), indent, text, path)
    }
}

function macrosTestViewMetadata() {
    text = []
    printMdObj(metadata.current.rootObject, "", text, "d:\\work\\temp\\testexport")
    var d = v8New("ТекстовыйДокумент")
    d.УстановитьТекст(text.join('\n'))
    d.Показать()
}

function macrosTestRepleace() {
    var w = GetTextWindow();
    if (!w) return;
    text = w.GetSelectedText();
    //Message(text)
    var re = new RegExp('^\\s*\/\/\{\{КОНСТРУКТОР_ЗАПРОСА_С_ОБРАБОТКОЙ_РЕЗУЛЬТАТА\\n\/\/ Данный фрагмент построен конструктором.\n\/\/ При повторном использовании конструктора, внесенные вручную изменения будут утеряны!!!','img');
    var text = text.replace(re,'');
    
    var re = new RegExp('\/\/\}\}КОНСТРУКТОР_ЗАПРОСА_С_ОБРАБОТКОЙ_РЕЗУЛЬТАТА','igm');
    Message(text+ 're'+re)
    var text = text.replace(re, '')
    w.SetSelectedText(text)
}

function macrosТестПоказВыпадающегоСписка() {

    // добавим в vimcomplite выподающий список из возможных варинатов... 

    //snegopat.showSmartBox();
    var words = snegopat.getHotWords();
    Message("l"+words.length)
    for (var i=0; i<words.length; i++){
        Message("dddd"+words[i]);
    }
}